//+------------------------------------------------------------------+
//|                                            Trevon_Balfour_EA.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

extern double order_lot=0.1;
extern bool money_management=false;
extern double risk_percent=2;
extern double take_profit=50;         				//Fixed takeprofit in pips (0=no takeprofit)
extern double SL_buffer_pips_before_profit=5;
extern double SL_buffer_pips_after_profit=5;


extern int ma_period=100;
extern int ma_shift=0;
extern ENUM_MA_METHOD ma_method=MODE_SMA;
extern ENUM_APPLIED_PRICE ma_apply_to=PRICE_CLOSE;

extern double minimum_ma_diff_pips=10;


extern ENUM_TIMEFRAMES timeframe_1=PERIOD_H4;
extern ENUM_TIMEFRAMES timeframe_2=PERIOD_H1;


extern int magic_number=730151;


double stop_loss=0;           				//Fixed stoploss in pips (0=no stoploss)
int max_trades=1;
double slippage=5;              			//Allowed slippage of open/close order
int bar=1;
int timeframe=0;
int number_retry_open_trade=10;

double     myPoint, mySpread, myStopLevel,myTickValue,myTickSize,myLotValue;
int        myDigits;
datetime   TradeBarTime;
bool       enable_ea;
double     my_lots;
int        digit_lot;

int signal;
int signalclose;
int myBars;
double last_history_check;
string TradeCode="TB_EA0.0";


   
int err;
string strsuffix;
double ratio=1000000;
double lastbid;
double lastmaH4;
double lastmaH1;
string strtype;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   SetPoint();
   if(Digits==3 || Digits==5) slippage*=10;
   if(MarketInfo(Symbol(),MODE_LOTSTEP)>=0.01) digit_lot=2;   
   if(MarketInfo(Symbol(),MODE_LOTSTEP)>=0.1) digit_lot=1;   
   if(MarketInfo(Symbol(),MODE_LOTSTEP)>=1) digit_lot=0;
   TradeBarTime=Time[0];
   strsuffix="_"+Symbol()+Period()+"_"+TradeCode+"_"+magic_number;

   DrawLine("last_bid"+strsuffix,Bid+ratio);
   
   double maH4_0=iMA(Symbol(),timeframe_1,ma_period,ma_shift,ma_method,ma_apply_to,0);
   double maH1_0=iMA(Symbol(),timeframe_2,ma_period,ma_shift,ma_method,ma_apply_to,0);
   
   DrawLine("last_maH4"+strsuffix,maH4_0+ratio);
   DrawLine("last_maH1"+strsuffix,maH1_0+ratio);
   
   if(IsTesting() || IsOptimization()) lastbid=Bid;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }

int signal()
{ 
   double close0=iClose(Symbol(),0,0);
   double openH4_0=iClose(Symbol(),timeframe_1,0);
   double openH1_0=iClose(Symbol(),timeframe_2,0);
   double closeH4_1=iClose(Symbol(),timeframe_1,1);
   double closeH1_1=iClose(Symbol(),timeframe_2,1);

   double maH4_0=iMA(Symbol(),timeframe_1,ma_period,ma_shift,ma_method,ma_apply_to,0);
   double maH1_0=iMA(Symbol(),timeframe_2,ma_period,ma_shift,ma_method,ma_apply_to,0);
   double maH4_1=iMA(Symbol(),timeframe_1,ma_period,ma_shift,ma_method,ma_apply_to,1);
   double maH1_1=iMA(Symbol(),timeframe_2,ma_period,ma_shift,ma_method,ma_apply_to,1);
   
   Comment("MA on H4=" + DoubleToStr(maH4_0,Digits) + " // MA on H1=" + DoubleToStr(maH1_0,Digits));
   
   bool valid_entry=false;
   if(MathAbs((maH4_0-maH1_0)/myPoint)>=minimum_ma_diff_pips ) valid_entry=true;
   
   
   bool buy=false; bool sell=false;
   
   if(valid_entry)
   {
      //Price above H4
      if(close0>maH4_0 && lastbid>lastmaH4)
      {
         if(close0>=maH1_0 && lastbid<lastmaH1) { buy=true; strtype=strtf(timeframe_2); }
         else if(close0<=maH1_0 && lastbid>lastmaH1) { buy=true; strtype=strtf(timeframe_2); }
      }
      //Price above H1
      if(close0>maH1_0 && lastbid>lastmaH1)
      {
         if(close0>=maH4_0 && lastbid<lastmaH4) { buy=true; strtype=strtf(timeframe_1); }
         else if(close0<=maH4_0 && lastbid>lastmaH4) { buy=true; strtype=strtf(timeframe_1); }
      }

      //Price below H4
      if(close0<maH4_0 && lastbid<lastmaH4)
      {
         if(close0<=maH1_0 && lastbid>lastmaH1) { sell=true; strtype=strtf(timeframe_2); }
         else if(close0>=maH1_0 && lastbid<lastmaH1) { sell=true; strtype=strtf(timeframe_2); }
      }
      //Price below H1
      if(close0<maH1_0 && lastbid<lastmaH1)
      {
         if(close0<=maH4_0 && lastbid>lastmaH4) { sell=true; strtype=strtf(timeframe_1); }
         else if(close0>=maH4_0 && lastbid<lastmaH4) { sell=true; strtype=strtf(timeframe_1); }
      } 
   }
   
   
   DrawLine("last_maH4"+strsuffix,maH4_0+ratio);
   DrawLine("last_maH1"+strsuffix,maH1_0+ratio);

   if(IsTesting() || IsOptimization())
   {
      lastmaH4=maH4_0;
      lastmaH1=maH1_0;
   }
   
   if(buy) return(10);
   if(sell) return(20);
   
   return(30);
}

void ManageSL()
{
   int tf=0;
   double ma1;
   double newsl;
   double close1;
   for (int cnt=OrdersTotal()-1; cnt >= 0; cnt--)
   {
      if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==True)
      {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic_number) 
         {
            if(StringFind(OrderComment(),strtf(timeframe_1)+"|")!=-1) tf=timeframe_1;
            if(StringFind(OrderComment(),strtf(timeframe_2)+"|")!=-1) tf=timeframe_2;
            if(OrderType()==OP_BUY)
            {
               if(iBarShift(Symbol(),timeframe_2,OrderOpenTime())==0)
               {
                  ma1=iMA(Symbol(),tf,ma_period,ma_shift,ma_method,ma_apply_to,0);
                  ModifyProfitTarget(OrderTicket(),OrderTakeProfit(),ma1-(SL_buffer_pips_before_profit*myPoint));
               }
               else if(iBarShift(Symbol(),timeframe_2,OrderOpenTime())>0)
               {
                  close1=iClose(Symbol(),timeframe_2,1);
                  newsl=close1-(SL_buffer_pips_after_profit*myPoint);
                  if(newsl>=OrderOpenPrice() && (newsl>OrderStopLoss() || OrderStopLoss()==0))
                  {
                     ModifyProfitTarget(OrderTicket(),OrderTakeProfit(),newsl);
                  }
                  if(newsl<OrderOpenPrice() || OrderStopLoss()==0)
                  {
                     ma1=iMA(Symbol(),tf,ma_period,ma_shift,ma_method,ma_apply_to,0);
                     ModifyProfitTarget(OrderTicket(),OrderTakeProfit(),ma1-(SL_buffer_pips_before_profit*myPoint));
                  }
               }
            }  
            else if(OrderType()==OP_SELL)
            {
               if(iBarShift(Symbol(),timeframe_2,OrderOpenTime())==0)
               {
                  ma1=iMA(Symbol(),tf,ma_period,ma_shift,ma_method,ma_apply_to,0);
                  ModifyProfitTarget(OrderTicket(),OrderTakeProfit(),ma1+(SL_buffer_pips_before_profit*myPoint));
               }
               else if(iBarShift(Symbol(),timeframe_2,OrderOpenTime())>0)
               {
                  close1=iClose(Symbol(),timeframe_2,1);
                  newsl=close1+(SL_buffer_pips_after_profit*myPoint);
                  if(newsl<=OrderOpenPrice() && (newsl<OrderStopLoss() || OrderStopLoss()==0))
                  {
                     ModifyProfitTarget(OrderTicket(),OrderTakeProfit(),newsl);
                  }
                  if(newsl>OrderOpenPrice() || OrderStopLoss()==0)
                  {
                     ma1=iMA(Symbol(),tf,ma_period,ma_shift,ma_method,ma_apply_to,0);
                     ModifyProfitTarget(OrderTicket(),OrderTakeProfit(),ma1+(SL_buffer_pips_before_profit*myPoint));
                  }
               }
            }       
         }
      }
   }
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   double sl,tp;   
   int openticket1;
   int openticket2;
   double openprice1;
   double openprice2;
   double stop;

   if(!IsTesting() && !IsOptimization())
   {
      lastbid=GetHLineValue("last_bid"+strsuffix)-ratio;
      lastmaH4=GetHLineValue("last_maH4"+strsuffix)-ratio;
      lastmaH1=GetHLineValue("last_maH1"+strsuffix)-ratio;
   }
   
   signal=signal();

   

   bool enableopen = true; 
   
   if(enableopen)
      if(TradeBarTime!=Time[0])
         if(signal!=30 )
            if(CountOpenOrders(OP_BUY)+CountOpenOrders(OP_SELL)<max_trades)
            {
               my_lots=order_lot;
               double my_lots2;
               if(money_management && stop_loss==0)
               {
                  my_lots2=(AccountBalance()*risk_percent*0.01)/(MarketInfo(Symbol(),MODE_MARGINREQUIRED));  
                  my_lots=NormalizeDouble(my_lots2,digit_lot);
               }
               else if(money_management && stop_loss>0)
               {
                  stop=stop_loss;
                  if(Digits==3 || Digits==5)
                     my_lots2=(AccountBalance()*risk_percent*0.01)/(stop * myTickValue*10);
                  else 
                     my_lots2=(AccountBalance()*risk_percent*0.01)/(stop * myTickValue);
                  my_lots=NormalizeDouble(my_lots2,digit_lot);
               }
               if(my_lots<MarketInfo(Symbol(),MODE_MINLOT)) my_lots=MarketInfo(Symbol(),MODE_MINLOT);
               if(my_lots>MarketInfo(Symbol(),MODE_MAXLOT)) my_lots=MarketInfo(Symbol(),MODE_MAXLOT);
               if(signal==10)
               {
                  openprice1=Ask;
                  if (stop_loss==0) sl=0;
                  if (stop_loss>0) sl=openprice1-(stop_loss*myPoint);
                  if (take_profit==0) tp=0;      
                  if (take_profit>0) tp=openprice1+(take_profit*myPoint); 
                  openticket1=Open_Trade(Symbol(),OP_BUY,openprice1, my_lots,sl, tp, strtype + "|" + TradeCode);
                  if(openticket1>0) 
                  {
                     Alert("Buy Alert "+ Symbol()+ " " + strtf(Period()) + " Date & Time: " + TimeToStr(TimeCurrent(),TIME_DATE)+" "+TimeToStr(TimeCurrent(),TIME_MINUTES) + " - " + WindowExpertName());
                  }
               }
               if(signal==20)
               {      
                  openprice2=Bid;
                  if (stop_loss==0) sl=0;
                  if (stop_loss>0) sl=openprice2+(stop_loss*myPoint);
                  if (take_profit==0) tp=0;      
                  if (take_profit>0) tp=openprice2-(take_profit*myPoint); 
                  openticket2=Open_Trade(Symbol(),OP_SELL,openprice2, my_lots,sl, tp, strtype + "|" +TradeCode);
                  if(openticket2>0) 
                  {
                     Alert("Sell Alert "+ Symbol()+ " " + strtf(Period()) + " Date & Time: " + TimeToStr(TimeCurrent(),TIME_DATE)+" "+TimeToStr(TimeCurrent(),TIME_MINUTES) + " - " + WindowExpertName());
                  }
               }
            }

   if(isNewCandle())
   {
      if(CountOpenOrders(OP_BUY)+CountOpenOrders(OP_SELL)>0)
      {
         ManageSL();
      }
   }

   if(IsTesting() || IsOptimization()) lastbid=Bid;
   
   DrawLine("last_bid"+strsuffix,Bid+ratio);
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+-------------------------General Functions------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+


void SetPoint()
{

   myPoint     =  MarketInfo(Symbol(),MODE_POINT);
   mySpread    =  MarketInfo(Symbol(),MODE_SPREAD);
   myDigits    =  MarketInfo(Symbol(),MODE_DIGITS);
   myStopLevel =  MarketInfo(Symbol(),MODE_STOPLEVEL);
   myTickValue = MarketInfo(Symbol(),MODE_TICKVALUE);
   myTickSize = MarketInfo(Symbol(),MODE_TICKSIZE);
   myLotValue = myTickValue/myTickSize;

   if(
         myDigits==3    ||  
         myDigits==5
     )
      {
         myPoint     =  myPoint  *  10;
         mySpread    =  mySpread /  10;
         myStopLevel =  myStopLevel / 10;
         myDigits    =  myDigits -1;
      }    

}

//+------------------------------------------------------------------+
//+----------------------Trading Hours-------------------------------+

bool istradinghours(int starthour, int endhour, int startminute=0, int endminute=0, int shift = 0)
{
   int nowtime = (Hour()+shift)*60 + Minute();
   if (nowtime < 0)
      nowtime += 1440;
   if (nowtime >= 1440)
      nowtime -= 1440;
   int starttime = starthour*60 + startminute;
   int endtime = endhour*60 + endminute;

   if (starttime <= endtime)
   {
      if ((nowtime < starttime) || (nowtime >= endtime))
         return(false);
   }
   else
   {
      if ((nowtime < starttime) && (nowtime >= endtime))
         return(false);
   }
   return(true);
}

//+------------------------------------------------------------------+
//+------------------Count Number of Open Orders---------------------+

int CountOpenOrders(int direction)
{
int i,j;
   

   
   j  =  0;
   
   for(i=OrdersTotal()-1;i>=0;i--)
      {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==True)
            {
               if(   OrderType()          == direction   &&
                     OrderSymbol()        == Symbol()          &&
                     OrderMagicNumber()   == magic_number     
                 )
                     j++;
            }
         else
            Print("Could not SELECT trade");
      }
   
   return(j);
}
//+------------------------------------------------------------------+
//+-------------------Close Trades by Symbol()-------------------------+

int CloseTrades(int direction)
{
int j;
//double ClosePrice;

   j  =  0;
   int x;
   int status;
   
   if(direction==-1)
      return(0);
      
   for(int cnt=OrdersTotal()-1;cnt>=0;cnt--)
      {
         if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)==True)
            {
               if(OrderSymbol()==Symbol() && 
                  OrderMagicNumber()==magic_number)                     
                  if(OrderType()==direction)
                     {
                        if(OrderType()==OP_BUY)
                           {
                              for (x = 5; x!= 0; x--) 
                              {                              
                                 while (IsTradeContextBusy() || !IsTradeAllowed()) Sleep(5000);
                                 status = OrderClose(OrderTicket(),OrderLots(),Bid,0);
                                 if (status == 1) { j++; break; }
                              }
                           }
                        else
                           if(OrderType()==OP_BUYLIMIT)
                              {
                                 for (x = 5; x!= 0; x--) 
                                 {                              
                                    while (IsTradeContextBusy() || !IsTradeAllowed()) Sleep(5000);
                                    status = OrderDelete(OrderTicket());
                                    if (status == 1) { j++; break; }
                                 }
                              }
                        else
                           if(OrderType()==OP_BUYSTOP)
                              {
                                 for (x = 5; x!= 0; x--) 
                                 {                              
                                    while (IsTradeContextBusy() || !IsTradeAllowed()) Sleep(5000);
                                    status = OrderDelete(OrderTicket());
                                    if (status == 1) { j++; break; }
                                 }
                              }
                        
                        if(OrderType()==OP_SELL)
                           {
                              for (x = 5; x!= 0; x--) 
                              {                              
                                 while (IsTradeContextBusy() || !IsTradeAllowed()) Sleep(5000);
                                 status = OrderClose(OrderTicket(),OrderLots(),Ask,0);
                                 if (status == 1) { j++; break; }
                              }
                           }
                        else
                           if(OrderType()==OP_SELLLIMIT)
                              {
                                 for (x = 5; x!= 0; x--) 
                                 {                              
                                    while (IsTradeContextBusy() || !IsTradeAllowed()) Sleep(5000);
                                    status = OrderDelete(OrderTicket());
                                    if (status == 1) { j++; break; }
                                 }
                              }
                        else
                           if(OrderType()==OP_SELLSTOP)
                              {
                                 for (x = 5; x!= 0; x--) 
                                 {                              
                                    while (IsTradeContextBusy() || !IsTradeAllowed()) Sleep(5000);
                                    status = OrderDelete(OrderTicket());
                                    if (status == 1) { j++; break; }
                                 }
                              }
                     }
            }
      }
   
   return(j);
}


//+------------------------------------------------------------------+
//+----------------Modify Profit Target and Stop Loss----------------+

bool ModifyProfitTarget(int myTicket, double ProfitTarget, double StopLoss)
{
   int try;
   if(OrderSelect(myTicket,SELECT_BY_TICKET,MODE_TRADES)==False)
      return(false);
            
      if(
            (
               MathRound(ProfitTarget/Point)   != MathRound(OrderTakeProfit()/Point)
               ||
               MathRound(StopLoss/Point)       != MathRound(OrderStopLoss()/Point)
            )                 
        )
            {
               //RefreshRates();
               for(try=1;try<=5;try++)
               {
                  if(OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(StopLoss,Digits),NormalizeDouble(ProfitTarget,Digits),OrderExpiration()))
                     return(true);
                  //else{
                  //   err=GetLastError();
                  //   Print("OrderModify Error # " + err + " : ",ErrorDescription(err));
                  //}
               }
            }
   return(false);
}







//+------------------------------------------------------------------+
//+----------------------OPEN TRADE----------------------------------+


int Open_Trade(string curr,int cmd,double price, double lot,double sl, double tp, string comm)
{

   int ticket,retry;
   color colour;
   
   sl=NormalizeDouble(sl,Digits);
   tp=NormalizeDouble(tp,Digits);
   price=NormalizeDouble(price,Digits);
   
   if(cmd==0) colour=Blue;
   if(cmd==1) colour=Red;
   
   if(Digits==3 || Digits==5) 
   {
      for(retry=1;retry<=number_retry_open_trade;retry++)
      {      
         RefreshRates();
         ticket=OrderSend(curr,cmd,lot,price,slippage,0,0,comm,magic_number,0,colour);
         if(ticket>0) break;
         //else {
         //   err=GetLastError();
         //   Print("OrderSend Error # " + err + " : ",ErrorDescription(err));
         //}
      }
   }
   else 
   {
      for(retry=1;retry<=number_retry_open_trade;retry++)
      {
         RefreshRates();
         ticket=OrderSend(curr,cmd,lot,price,slippage,sl,tp,comm,magic_number,0,colour);   
         if(ticket>0) break;  
         //else {
         //   err=GetLastError();
         //   Print("OrderSend Error # " + err + " : ",ErrorDescription(err));
         //}
      }
   }
         
   if(ticket>0)
   {
      if(Digits==3 || Digits==5)
      {
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
            for(retry=1;retry<=number_retry_open_trade;retry++)
            {
               if(ModifyProfitTarget(ticket, tp, sl))
               break;
            }
      }
      TradeBarTime=Time[0];
      return(ticket);
   }
   return(0);
}

bool isNewCandle()  
{
   bool res=false;
   if (myBars!=Bars)
   {
      myBars=Bars;
      res=true;
   }

return(res);   

}



//+------------------------------------------------------------------+
//+-----------------------------Draw Line----------------------------+


void DrawLine(string sName, double dPrice,color cLineClr=CLR_NONE)
{
    int iWidth=1;
    string sObjName = sName;

    if(ObjectFind(sObjName) == -1){
        // create object 
        ObjectCreate(sObjName,OBJ_HLINE, 0, 0,0);
    }

    ObjectSet(sObjName,OBJPROP_PRICE1,dPrice);
    ObjectSet(sObjName, OBJPROP_COLOR, cLineClr);
    ObjectSet(sObjName, OBJPROP_WIDTH, iWidth);
}

//+------------------------------------------------------------------+
//+---------------------------Get Line Price-------------------------+


double GetHLineValue(string name)
{

   if (ObjectFind(name) == -1)
      return(-1);
   else
      return(ObjectGet(name,OBJPROP_PRICE1));
}




string strtf(int tf)
{
   switch(tf)
   {
      case PERIOD_M1: return("M1");
      case PERIOD_M5: return("M5");
      case PERIOD_M15: return("M15");
      case PERIOD_M30: return("M30");
      case PERIOD_H1: return("H1");
      case PERIOD_H4: return("H4");
      case PERIOD_D1: return("D1");
      case PERIOD_W1: return("W1");
      case PERIOD_MN1: return("MN1");
      default:return("Unknown timeframe");
   }
}
